{% extends 'base/base.html' %}

{% block base_title %}
    Add a new task
{% endblock %}

{% block base_content %}
    <div class="container jumbotron" id="root">
        <div>
            <h1>Add new task</h1>
            <div class="lead">
                A <span class="font-italic">task</span> target a subset of workers with specific abilities able to answer the needs of the <span class="font-italic">requester</span>.
                It is composed of two parts :
                <br>
                - <span class="font-italic">Generic informations</span> (here as a title and a text description) given by the requester to concretely describe his task.
                <br>
                - The task <span class="font-italic">meta-data</span> consisting, for each skill, of a minimum and a maximum skill level for the workers to apply.
                <br>
                A <span class="font-italic">task desgin</span> system help the requester <span class="font-italic">tune</span> the task knowing how much workers will be fit for it.

            </div>
            <hr class="my-4">
        </div>

        <form method="post">
            {% csrf_token %}

            <div>
                <div class="form-group">
                    <label for="title">Title :</label>
                    <input name="title" type="text" class="form-control" placeholder="Task name" v-model="title"/>
                </div>

                <div class="form-group">
                    <label for="descr">Description :</label>
                    <textarea name="descr" class="form-control" rows="3" v-model="descr"></textarea>
                </div>
                <hr>
            </div>

            <div>
                <h4>Select a tree</h4>
                <div class="form-group">
                    <label for="tree">Select a tree</label>
                    <select name="tree" class="form-control" v-model="tree" v-on:change="getHelper()">
                        <option v-for="tree in trees" v-bind:value="tree">Tree [[ tree ]]</option>
                    </select>
                </div>
                <hr>
            </div>

            <div>
                <h4>Your task</h4>

                <div class="d-flex flex-column">
                    {% for ability in abilities %}
                        <div class="p-2 d-flex flex-row">
                            <div class="p-2 font-weight-bold">
                                &#8226 {{ ability.name }} :
                            </div>
                            <div class="p-2">
                                {{ ability.descr }}
                            </div>
                        </div>

                        <div class="p-2 d-flex flex-row">
                            <div class="p-2 d-flex flex-column">
                                <div class="d-flex justify-content-center">
                                    <label>Ability (minimum)</label>
                                </div>

                                {% include 'base/ability_slider.html' with asid=ability.id type='min' %}
                            </div>
                            <div class="p-2 d-flex flex-column ml-auto">
                                <div class="d-flex justify-content-center">
                                    <label>Ability (maximum)</label>
                                </div>

                                {% include 'base/ability_slider.html' with asid=ability.id type='max' %}
                            </div>
                        </div>

                        <div class="d-flex">
                            <input hidden type="range" name="min_{{ ability.id }}"
                                   min="0.0" max="1.0" step="0.1" v-model="ab_{{ ability.id }}_min">
                            <input hidden type="range" name="max_{{ ability.id }}"
                                   min="0.0" max="1.0" step="0.1" v-model="ab_{{ ability.id }}_max">

                            <div class="progress flex-fill ml-2" style="background-color: lightgrey">
                                <div class="progress-bar bg-danger" role="progressbar"
                                     :style="{ width: w_min_{{ ability.id }} + '%' }">[[ ab_{{ ability.id }}_min ]]
                                </div>
                                <div class="progress-bar bg-success" role="progressbar"
                                     :style="{ width: w_range_{{ ability.id }} + '%' }">[[ ab_{{ ability.id }}_min ]]
                                    - [[ ab_{{ ability.id }}_max ]]
                                </div>
                                <div class="progress-bar bg-danger" role="progressbar"
                                     :style="{ width: w_left_{{ ability.id }} + '%' }">[[ ab_{{ ability.id }}_max ]]
                                </div>
                            </div>
                        </div>
                    {% endfor %}
                </div>

                <hr>
            </div>

            <div>
                <div class="d-flex flex-row">
                    <h4>Task informations</h4>
                    <div v-if="!mode" class="ml-auto d-flex flex-row">
                        <button type="button" class="btn btn-primary" v-on:click="change_mode(true)">
                            Informed mode
                        </button>
                    </div>

                    <div v-if="mode" class="ml-auto d-flex flex-row">
                        <button type="button" class="btn btn-primary" v-on:click="change_mode(false)">
                            Guess mode
                        </button>
                    </div>
                </div>

                <!-- Partie guessing -->
                <div v-if="!mode" class="mt-5">
                    <div class="d-flex flex-column">
                        <div class="d-flex flex-row justify-content-center">
                            <p>Guess the number of workers concerned by your task</p>
                        </div>

                        <div class="d-flex flex-row justify-content-center">
                            <input type="number" step="1" min=0 v-model="guess" v-on:change="unmake_guess()">
                        </div>

                        <div class="d-flex flex-row justify-content-center mt-4">
                            <button type="button" class="btn btn-primary" v-on:click="make_guess()">
                                Make a guess
                            </button>
                        </div>

                        <div v-if="guessed" class="d-flex flex-row justify-content-center mt-4">
                            There is [[ real_count ]] workers in the task area ([[ guess_diff ]] % of error)
                        </div>

                        <div v-if="guessed" class="d-flex flex-row justify-content-center mt-4">
                            <button type="button" class="btn btn-primary" v-on:click="change_mode(true)">
                                See the informed mode.
                            </button>
                        </div>

                    </div>
                </div>

                <!-- Partie avec les informations connues sur l'arbre -->
                <div v-if="mode" class="mt-5 text-center">
                    <div class="p-2">
                        Real number of workers (without PKD): [[ real_count ]]
                    </div>
                    <div class="p-2">
                        Unperturbed approximation of the number of workers (with PKD) : [[ tree_real_count ]] ([[ tree_real_count_diff ]] % of error)
                    </div>
                    <div class="p-2">
                        Perturbed approximation of the number of workers (with PKD) : [[ pert_count ]] ([[ pert_count_diff ]] % of error)
                    </div>
                    <div class="p-2">
                        Number of nodes concerned by the task : [[ nodes ]]
                    </div>
                </div>
                <hr>
            </div>

            <div class="p-2">
                <button class="btn btn-primary">
                    Create
                </button>
            </div>
        </form>
    </div>
    <script>
        new Vue({
            el: '#root',
            delimiters: ['[[', ']]'],
            data: {
                title: "{{ form.title.value }}",
                descr: "{{ form.descr.value }}",
                tree: {{ trees.first.id }},
                trees: [{% for tree in trees %}{{ tree.id }}, {% endfor %}],
                {% for ability in abilities %}
                    ab_{{ ability.id }}_min: 0.0,
                    ab_{{ ability.id }}_max: 1.0,
                    old_{{ ability.id }}_min: 0.0,
                    old_{{ ability.id }}_max: 0.0,
                    w_min_{{ ability.id }}: 0.0,
                    w_range_{{ ability.id }}: 0.0,
                    w_left_{{ ability.id }}: 0.0,
                {% endfor %}
                csrf_token: '',
                mode: false, // false : guessing mode, true : informed mode
                guess: 0,
                guess_diff: 0,
                guessed: false,
                loading: false,
                real_count: null,
                tree_real_count: null,
                tree_real_count_diff: null,
                pert_count: null,
                pert_count_diff: null,
                nodes: null
            },
            mounted: function () {
                this.getHelper();
            },
            methods: {
                ab_min: function (id, type) {
                    var id = "ab_" + id.toString() + "_" + type;
                    if (this[id] > 0.0) {
                        var nid = +this[id] - 0.1;
                        this[id] = nid.toFixed(1);
                    }
                },
                ab_plus: function (id, type) {
                    var id = "ab_" + id.toString() + "_" + type;
                    if (this[id] < 1.0) {
                        var nid = +this[id] + 0.1;
                        this[id] = nid.toFixed(1);
                    }
                },
                hndlChange(id) {
                    var ab_min = "ab_" + id.toString() + "_min";
                    var ab_max = "ab_" + id.toString() + "_max";

                    // ensure that min < max. If min > max -> swap the values
                    if (this[ab_min] > this[ab_max]) {
                        var tmp = this[ab_min];
                        this[ab_min] = this[ab_max];
                        this[ab_max] = tmp;
                    }

                    // Display CSS calculation
                    var w_min = 'w_min_' + id;
                    var w_range = 'w_range_' + id;
                    var w_left = 'w_left_' + id;

                    this[w_min] = this[ab_min] * 100;
                    var w_max = this[ab_max] * 100;
                    this[w_range] = w_max - this[w_min];
                    this[w_left] = 100 - w_max;

                    // Update counts with the API
                    var old_min = "old_" + id.toString() + "_min";
                    var old_max = "old_" + id.toString() + "_max";
                    if (this[ab_min] != this[old_min] || this[ab_max] != this[old_max]) {
                        this[old_min] = this[ab_min];
                        this[old_max] = this[ab_max];

                        this.getHelper();
                    }
                },
                getHelper() {
                    fetch("{% url 'tasks-helper-api' %}", {
                        method: 'POST',
                        body: JSON.stringify({
                            tree: this.tree,
                            {% for ability in abilities %}
                                ab_min_{{ ability.id }}: this.ab_{{ ability.id }}_min,
                                ab_max_{{ ability.id }}: this.ab_{{ ability.id }}_max,
                            {% endfor %}
                        })
                    }).then((res) => res.json())
                        .catch((err) => {
                            console.log(err);
                            this.loading = false;
                        }).then(data => {
                        if (data.error == null) {
                            console.log(data);
                            this.real_count = data.real_count;
                            this.tree_real_count = data.tree_real_count.toFixed(0);
                            this.tree_real_count_diff = Math.abs((this.real_count - this.tree_real_count) * 100 / this.real_count).toFixed(2);

                            this.pert_count = data.tree_pert_count.toFixed(0);
                            this.pert_count_diff = Math.abs((this.real_count - this.pert_count) * 100 / this.real_count).toFixed(2);
                            this.nodes = data.nodes;
                        } else {
                            console.log(data.error);
                            this.loading = false;
                        }
                    })
                },
                change_mode(v) {
                    this.mode = v;
                },
                unmake_guess() {
                    this.guessed = false;
                },
                make_guess() {
                    this.guessed = true;

                    this.guess_diff = Math.abs((this.real_count - this.guess) * 100 / this.real_count).toFixed(2);
                }
            }
        })

    </script>


{% endblock %}
